#! /usr/bin/env python
from circlemeter import *

class MemMeter( Monitor ):
    def __init__( self, scfg, skin ):
        self.config = scfg.items( 'MemMeter' )
        Monitor.__init__( self, self.config, skin )
    
    def update_dict( self ):
        x = sg_get_mem_stats()
        self.dict['total'] = int(round( x['total'] / 1024 / 1024 ))
        self.dict['used'] = int(round((x['used'] - x['cache']) / 1024 / 1024 ))
        self.dict['usedperc'] = int(round(float(self.dict['used']) / float(self.dict['total']) * 100))
            
    def update_deg( self ):
        self.deg = 360 * self.dict['used'] / self.dict['total']

cpu = MemMeter( scfg, skin )
Circle_meter( cpu ).pause()
