#! /usr/bin/env python
import dbus
import gobject
import dbus.glib
import threading
from time import time

from song_info import *
from circlemeter import *

class SongMeter( Monitor ):
    def __init__( self, scfg, skin, song ):
        self.song = song
        self.config = scfg.items( 'SongMeter' )
        Monitor.__init__( self, self.config, skin )
    
    def update_dict( self ):
        self.song.update_dict()
        self.dict = self.song.dict
            
    def update_deg( self ):
        len = int(self.dict['~#length'])
        if self.dict['t_elapsed'] > len:
            self.deg = 360
            return
        if len != 0:
            self.deg = 360 * int(self.dict['t_elapsed']) / len
        else:
            self.deg = 0


# some globals
path = '/net/sacredchao/QuodLibet'
interface = 'net.sacredchao.QuodLibet'
busname = 'net.sacredchao.QuodLibet'

class BusQL: 
    def __init__( self, desklet ):
        self.desklet = desklet
        self.set_signal_receivers()
        
    def runloop( self ):
        mainloop = gobject.MainLoop()
        mainloop.run()
    
    def song_started( self, song ):
        print 'Song started!'
        self.desklet.cpu.song = SongInfo( song )
        self.desklet.refresh()
    
    def set_signal_receivers( self ):
        bus = dbus.SessionBus()
        try:
            bus.add_signal_receiver( self.song_started, 'SongStarted', interface )
        except:
            print 'WTF?'

class DeskletBg( threading.Thread ):
    def __init__( self, desklet ):
        threading.Thread.__init__( self )
        self.desklet = desklet
        
    def run( self ):
        self.desklet.pause()

def get_iface():
    bus = dbus.SessionBus()
    try:
        proxy = bus.get_object( busname, path )
        iface = dbus.Interface( proxy, interface )
    except:
        return False
    return iface

def get_current( iface ):
    try:
        cs = iface.CurrentSong()
    except:
        return {'artist': 'None',
                'album': 'None',
                'title': 'None',
                '~#rating': 0,
                '~#laststarted': time(),
                '~#length': 0,
                '_playing_': False}
    return cs

ql_iface = get_iface()
cur = get_current( ql_iface )

playing = True
if '_playing_' in cur:
    playing = False

song = SongInfo( cur )
song_meter = SongMeter( scfg, skin, song )
desk = Circle_meter( song_meter )

desk_bg = DeskletBg( desk )
desk_bg.start()

mybus = BusQL( desk )
mybus.runloop()
